//Kode utdelt for oblig 2 inf[34]110 hsten 2005
//Versjon 1. Koden ble skrevet p ca 3 timer. Bugs
// kan derfor tenkes  forekomme, og rapporteres
// i tilfellet til sigmundn@ifi.uio.no.

import java.io.*;

final class Interpreter {
    public static void main(String [] args) {
        Scanner.initiate(args[0]);
        ProgramNode pn = new ProgramNode();
        pn.parse();
      
        /******** Your code here **********/
    }
}

/* Performs tokenizing of the input file */
final class Scanner {

    static private BufferedReader file; //the input file
    static private StringBuffer buffer; //current token (or part thereof)
    static private String line;         //the current line
    static private int position;        //position on the line
    static private int linenumber;      //number of the line
    static private String next;         //next symbol (for the user)
    static private String curr;         //current symbol (for the user)
    
    /* Initiates the scanner */
    public static void initiate(String filename) {
        linenumber = 1;

        try {
            file = new BufferedReader(new FileReader(filename));
            line = "";
            while (line.equals("")) {
                line = file.readLine();
                if (line==null) System.exit(0);
                linenumber++;
            }
        } catch (IOException e) {
            System.err.println("Couldn't open file " + filename);
            System.exit(1);
        }
        position = 0;
        buffer = new StringBuffer();
        proceed();
        proceed();
    }

    /* Proceeds one step in the input file. */
    public static void proceed() {
        curr = next;
        next = "";
        try {
            while (next.equals("")) {
                next = getNext();
                if (next != null) {
                    next = next.trim();
                } else {
                    break;
                }
            }
        } catch (EOFException eof) {
            next = null;
        } catch (IOException ioe) {
            error("Error reading the next symbol from file.");
        }
        //System.out.println(curr);
    }

    /* Helper function for proceed() */
    private static String getNext() throws IOException {
        char tmp1,tmp2;
        
        //if line==null, we're at the end of the file
        if (line==null) return null;

        buffer.delete(0,buffer.length());
        
        while (true) {
            //Read character
            tmp1 = line.charAt(position++);
            //Make sure we always have data to read from
            if (position == line.length()) {
                line = "";
                while (line.equals("")) {
                    line = file.readLine();
                    if (line == null) break;
                    linenumber++;
                }
                position = 0;
            }
            //View next character
            if (line != null) {
                tmp2 = line.charAt(position);
            } else {
                tmp2 = 0;
            }

            //Add to buffer:
            buffer.append(tmp1);
            //Check for finished symbol
            if (isKeySymbol(tmp1) || 
                (line != null && 
                 (Character.isWhitespace(tmp2) || isKeySymbol(tmp2)))) {
                return buffer.toString();
            }
            if (line == null) return null;
        }
    }
    
    /* Helper function for getNext() */
    private static boolean isKeySymbol(char a) {
        if ((a == '(') || (a == ')') || (a == '{') || (a == '}') ||
            (a == '=') || (a == '+') || (a == '-') || (a == ';')) {
            return true;
        } else {
            return false;
        }
    }
            
    /* Returns the current symbol. Used to see
     * what the current symbol is. */
    public static String viewCurr() {
        if (curr == null) {
            return "";
        }
        return curr;
    }

    /* Returns the next symbol. Used to see
     * what the next symbol is. */
    public static String viewNext() {
        if (next == null) {
            return "";
        }
        return next;
    }

    /* Returns whether a given token is a valid name. */
    public static boolean isName(String token) {
        return token.matches("^[a-zA-Z]+$") 
            && !(token.equals("int") || token.equals("double")
                 || token.equals("print") || token.equals("return")
                 || token.equals("fun")   || token.equals("var"));
    }

    /* Returns whether a given token is a valid integer. */
    public static boolean isInteger(String token) {
        return token.matches("^(0|[1-9][0-9]*)$");
    }

    /* Returns whether a given token is a valid double. */
    public static boolean isDouble(String token) {
        return token.matches("^(0|[1-9][0-9]*)\\.[0-9]+$");
    }

    /* Returns whether a given token is a valid operator. */
    public static boolean isOperator(String token) {
        return token.equals("+") || token.equals("-");
    }

    /* Prints an error message during parsing. */
    public static void error(String msg) {
        System.err.println("Error: "+msg);
        System.err.println("Was parsing symbols "+curr+" and "+next+" near line "+linenumber);
        System.exit(1);
    }
}

final class ProgramNode {
    
    // The program consists of a function, stored here:
    FunDeclNode mainfunction;

    /* Parses the program. */
    public void parse() {
        mainfunction = new FunDeclNode();
        mainfunction.parse();
    }
}

/* Superclass of all statements. */
abstract class StatementNode {
    public StatementNode next;
    public abstract void parse();
}

/* Represents function declarations in the parse tree */
final class FunDeclNode extends StatementNode {

    TypeNode type;          //The type of the function
    String   name;          //The name of the function
    ExprNode retValue;      //The expression of the functions return value
    VarDeclNode parameter;  //The parameter of the function
    StatementNode content;  //The statements of the function

    /* Parses a function declaration */
    public void parse() {
        StatementNode tmp1;
        
        //Parse type
        type = new TypeNode();
        type.parse();

        //Parse fun
        if (!Scanner.viewCurr().equals("fun")) {
            Scanner.error("Expected \"fun\"");
        }
        Scanner.proceed();

        //Parse name
        name = Scanner.viewCurr();
        if (!Scanner.isName(name)) {
            Scanner.error("Illegal name of declared function: "+name);
        }
        Scanner.proceed();

        //Parse (
        if (!Scanner.viewCurr().equals("(")) {
            Scanner.error("Expected \"(\"");
        }
        Scanner.proceed();

        //Parse parameter
        parameter = new VarDeclNode();
        parameter.parse();

        //Parse )
        if (!Scanner.viewCurr().equals(")")) {
            Scanner.error("Expected \")\"");
        }
        Scanner.proceed();

        //Parse {
        if (!Scanner.viewCurr().equals("{")) {
            Scanner.error("Expected \"{\"");
        }
        Scanner.proceed();
        
        //Parse statements
        content = tmp1 = newStatement();
        tmp1.parse();
        if (!Scanner.viewCurr().equals(";")) {
            Scanner.error("Expected ;");
        }
        Scanner.proceed();
        while (!Scanner.viewCurr().equals("return")) {
            tmp1.next = newStatement();
            tmp1 = tmp1.next;
            tmp1.parse();
            if (!Scanner.viewCurr().equals(";")) {
                Scanner.error("Expected ;");
            }
            Scanner.proceed();
        }

        //Parse return
        if (!Scanner.viewCurr().equals("return")) {
            Scanner.error("Expected \"return\"");
        }
        Scanner.proceed();

        //Parse return expression
        retValue = new ExprNode();
        retValue.parse();

        //Parse }
        if (!Scanner.viewCurr().equals("}")) {
            Scanner.error("Expected \"}\"");
        }
        Scanner.proceed();
    }
    
    /* Creates a new statement-node */
    private StatementNode newStatement() {
        if (Scanner.viewNext().equals("fun")) {
            return new FunDeclNode();
        } else if (Scanner.viewNext().equals("var")) {
            return new VarDeclNode();
        } else if (Scanner.viewNext().equals("(")) {
            return new CallNode();
        } else if (Scanner.viewNext().equals("=")) {
            return new AssignNode();
        } else {
            Scanner.error("Illegal statement definition.");
            return null; //Dummy statement, not reached
        }
    }
}

/* Represents a variable declaration in the parse tree */
final class VarDeclNode extends StatementNode {
    
    TypeNode type;
    String   name;

    /* Parses a variable declaration */
    public void parse() {
        //Parse type
        type = new TypeNode();
        type.parse();

        //Parse var
        if (!Scanner.viewCurr().equals("var")) {
            Scanner.error("Expected \"var\"");
        }
        Scanner.proceed();

        //Parse name
        name = Scanner.viewCurr();
        if (!Scanner.isName(name)) {
            Scanner.error("Illegal name of declared variable: "+name);
        }
        Scanner.proceed();
    }
}

/* Supertype of all terms. Add other interfaces as needed! */
interface TermNode {
    public void parse();
}

/* Represents function calls in the parse tree. */
final class CallNode extends StatementNode implements TermNode {
    
    String   name;        //Name of the function to be called
    ExprNode actualParam; //The actual parameter to the function
    
    /* Parses a function call */
    public void parse() {
        //Parse name
        name = Scanner.viewCurr();
        if (!Scanner.isName(name)) {
            Scanner.error("Illegal name of called function: "+name);
        }
        Scanner.proceed();

        //Parse (
        if (!Scanner.viewCurr().equals("(")) {
            Scanner.error("Expected \"(\"");
        }
        Scanner.proceed();
        
        //Parse actual parameter
        actualParam = new ExprNode();
        actualParam.parse();
        
        //Parse )
        if (!Scanner.viewCurr().equals(")")) {
            Scanner.error("Expected \")\"");
        }
        Scanner.proceed();
    }
}

/* Represents assignments in the parse tree */
final class AssignNode extends StatementNode {
    
    String   name; //The name of the variable to be assigned to
    ExprNode expr; //The expression specifying the value to be assigned

    /* Parses the assignment */
    public void parse() {
        //Parse name
        name = Scanner.viewCurr();
        if (!Scanner.isName(name)) {
            Scanner.error("Illegal name of assignment target: "+name);
        }
        Scanner.proceed();

        //Parse =
        if (!Scanner.viewCurr().equals("=")) {
            Scanner.error("Expected \"=\"");
        }
        Scanner.proceed();
        
        //Parse actual parameter
        expr = new ExprNode();
        expr.parse();
    }

}

/* Represents types in the parse tree.
 * Uses a char variable to store the type.
 * i = integer, d = double */
final class TypeNode {

    char type; //The type (i or d)
    
    /* Parses a type */
    public void parse() {
        //Parse type
        if (Scanner.viewCurr().equals("int")) {
            type = 'i';
            Scanner.proceed();
        } else if (Scanner.viewCurr().equals("double")) {
            type = 'd';
            Scanner.proceed();
        } else {
            Scanner.error("Expected \"int\" or \"double\".");
        }
    }
}

/* Represents an expression in the parse tree */
final class ExprNode {
    TermNode term; //The left term of the expression
    OpNode   op = null;   //The (optional) operator of the expression
    ExprNode expr = null; //The (optional) right part of the expression
    
    /* Parses an expression */
    public void parse() {
        term = newTerm();
        term.parse();
    
        if (Scanner.isOperator(Scanner.viewCurr())) {
            op = new OpNode();
            op.parse();
            expr = new ExprNode();
            expr.parse();
        }
    }
    
    /* Creates a new term in the expression */
    private TermNode newTerm() {
        String tmp1 = Scanner.viewCurr();
        if (Scanner.viewNext().equals("(")) {
            return new CallNode();
        } else if (Scanner.isName(tmp1)) {
            return new VarUseNode();
        } else if (Scanner.isInteger(tmp1)) {
            return new IntegerNode();
        } else if (Scanner.isDouble(tmp1)) {
            return new DoubleNode();
        } else {
            Scanner.error("Illegal term definition!");
            return null; //Dummy statement, not reached
        }
    }
}
        
/* Represents an operator in the parse tree. */
final class OpNode {
    char op; //The operator

    /* PArses an operator */
    public void parse() {
        String tmp = Scanner.viewCurr();
        if (tmp.equals("+")) {
            op = '+';
        } else if (tmp.equals("-")) {
            op = '-';
        } else {
            Scanner.error("Operator expected, found "+tmp);
        }
        Scanner.proceed();
    }

    /* performs a calculation between two doubles,
       based on the type of operator. */
    public double calculate(double a, double b) {
        if (op == '+') {
            return a+b;
        } else if (op == '-') {
            return a-b;
        } else {
            System.out.println("Illegal operation: "+op);
            System.exit(-1);
            return 0; //Dummy statement, not reached
        }
    }
}

/* Represents the use of a variable in the parse tree. */
final class VarUseNode implements TermNode {
    String name; //Name of the variable being used
    
    /* Parses the use of a variable. */
    public void parse() {
        //Parse name
        name = Scanner.viewCurr();
        if (!Scanner.isName(name)) {
            Scanner.error("Illegal name of used variable: "+name);
        }
        Scanner.proceed();
    }    
}

/* Represents an integer in the parse tree. */
final class IntegerNode implements TermNode {
    int value;

    /* Parses an integer */
    public void parse() {
        String tmp;
        //Parse value
        tmp = Scanner.viewCurr();
        if (!Scanner.isInteger(tmp)) {
            Scanner.error("Expected integer value, found "+tmp);
        }
        value = Integer.parseInt(tmp);
        Scanner.proceed();
    }
}

/* Represents a double in the parse tree. */
final class DoubleNode implements TermNode {
    double value;

    /* Parses a double */
    public void parse() {
        String tmp;
        //Parse value
        tmp = Scanner.viewCurr();
        if (!Scanner.isDouble(tmp)) {
            Scanner.error("Expected double value, found "+tmp);
        }
        value = Double.parseDouble(tmp);
        Scanner.proceed();
    }
}
